/*****************************************************************************/
/*
                                 Proxy.h

08-AUG-1998  MGD  initial
*/
/*****************************************************************************/

#ifndef PROXYTUNNEL_H_LOADED
#define PROXYTUNNEL_H_LOADED 1

/* tunnel functionality (any changes must be reflected in accounting struct) */
#define PROXY_TUNNEL_CONNECT   1   /* in service plus out proxy */
#define PROXY_TUNNEL_FIREWALL  2   /* in service plus out proxy */
#define PROXY_TUNNEL_HTTP      3   /* out proxy only */
#define PROXY_TUNNEL_HTTPS     4   /* out proxy only */
#define PROXY_TUNNEL_RAW    5   /* in service plus out proxy */

/***********************/
/* function prototypes */
/***********************/

/* forward references */
typedef struct ProxyTaskStruct PROXY_TASK;
typedef struct RequestStruct REQUEST_STRUCT;

ProxyTunnelConnectResponseAst (REQUEST_STRUCT *);
ProxyTunnelRequestResponseAst (PROXY_TASK*);
ProxyTunnelNetReadAst (REQUEST_STRUCT*);
ProxyTunnelNetWriteAst (REQUEST_STRUCT*);
ProxyTunnelReadAst (PROXY_TASK*);
ProxyTunnelRequestRebuild (PROXY_TASK*);
ProxyTunnelRequestParse (REQUEST_STRUCT*);
ProxyTunnelWriteAst (PROXY_TASK*);

#endif /* PROXYTUNNEL_H_LOADED */

/*****************************************************************************/

